select *
from sales
match_recognize(
  partition by prod_id
  order by time_id
  measures strt.time_id as start_date,
  last(down.time_id) as bottom_date,
  last(up.time_id) as   end_date,
  sum(amount_sold) as tot_sold
   one row per match
   after match skip to last up
   pattern (strt down+ up+)
   define
     down as down.amount_sold < prev(down.amount_sold),
     up as up.amount_sold > prev(up.amount_sold)
   ) matcher
 where prod_id = 13
 order by matcher.start_date
/
